/* Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null primary key, Nazwa varchar(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int references Jednostka(ID), Imie varchar(30), Nazwisko varchar(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace TransactionsExample
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection conn = new SqlConnection("Data Source=.; Initial Catalog=KursPBD; Integrated Security=true");
            conn.Open();

            SqlTransaction tx = conn.BeginTransaction();

            SqlCommand c1 = new SqlCommand("INSERT INTO Osoba (ID, Imie, Nazwisko) VALUES(10,'Jan1', 'Kowalski1')", conn);
            SqlCommand c2 = new SqlCommand("INSERT INTO Osoba (ID, Imie, Nazwisko) VALUES(11,'Jan2', 'Kowalski2')", conn);

            // Oba ponisze przypisania musz by
            c1.Transaction = tx;
            c2.Transaction = tx;

            try
            {
                c1.ExecuteNonQuery();
                c2.ExecuteNonQuery();
                tx.Commit();
                Console.WriteLine("OK");
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                
                tx.Rollback();
                Console.WriteLine("Error");
            }
            finally
            {
                conn.Close();
            }
            Console.ReadLine();
        }
    }
}
