/* Przygotowanie bazy danych

drop table Osoba;
drop table Sekwencje;
drop table Dziennik;

create table Dziennik
(
  ID int not null primary key,
  Tabela varchar(255) not null,
  RekordID int not null,
  Operacja varchar(10) not null,
  Data datetime
)

create table Sekwencje(
  Tabela varchar(255) not null primary key,
  Liczba int not null default 0
)

begin
  insert into Sekwencje(Tabela) values('Osoba');
  insert into Sekwencje(Tabela) values('Dziennik');
end;

create table Osoba(
  ID int not null primary key,
  Imie varchar(30),
  Nazwisko varchar(50),
  Pensja int
)

begin
  insert into Osoba values( 1, 'Jan', 'Kowalski', 1000 );
  insert into Dziennik values( 1, 'Osoba', 1, 'INSERT', GetDate() );
  insert into Osoba values( 2, 'Ewa', 'Solska', 1200 );
  insert into Dziennik values( 2, 'Osoba', 2, 'INSERT', GetDate() );
  insert into Osoba values( 3, 'Boydar', 'Nowak', 1500 );
  insert into Dziennik values( 3, 'Osoba', 3, 'INSERT', GetDate() );
  insert into Osoba values( 4, 'Adam', 'Adamski', 1700 );
  insert into Dziennik values( 4, 'Osoba', 4, 'INSERT', GetDate() );
  insert into Osoba values( 5, 'Zygmunt', 'Riposta', 1240 );
  insert into Dziennik values( 5, 'Osoba', 5, 'INSERT', GetDate() );
  insert into Osoba values( 6, 'Alicja', 'Gleba', 1600 );
  insert into Dziennik values( 6, 'Osoba', 6, 'INSERT', GetDate() );
  insert into Osoba values( 7, 'Tania', 'Borwka', 1560 );
  insert into Dziennik values( 7, 'Osoba', 7, 'INSERT', GetDate() );
  insert into Osoba values( 8, 'Natasza', 'Lizacka', 2500 );
  insert into Dziennik values( 8, 'Osoba', 8, 'INSERT', GetDate() );
  insert into Osoba values( 9, 'Stan', 'Taczkowski', 1900 );
  insert into Dziennik values( 9, 'Osoba', 9, 'INSERT', GetDate() );
  update Sekwencje set Liczba=10 where Tabela='Osoba';
  update Sekwencje set Liczba=10 where Tabela='Dziennik';
end;
*/


using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace TransactionsExample2
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection connection = null;
            SqlTransaction transaction = null;

            connection = new SqlConnection("Data Source=.; Initial Catalog=KursPBD; Integrated Security=true");
            connection.Open();

            for (int i = 0; i < 10; i++)
            {
                int IdOsoba;
                int IdDziennik;
                try
                {
                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = connection;

                    transaction = connection.BeginTransaction();
                    cmd.Transaction = transaction;

                    cmd.CommandText = "SELECT Liczba FROM Sekwencje WHERE Tabela='Osoba'";
                    IdOsoba = (int)cmd.ExecuteScalar();

                    cmd.CommandText = "UPDATE Sekwencje SET Liczba=Liczba+1 WHERE Tabela='Osoba'";
                    cmd.ExecuteNonQuery();

                    transaction.Commit();


                    transaction = connection.BeginTransaction();
                    cmd.Transaction = transaction;

                    cmd.CommandText = "SELECT Liczba FROM Sekwencje WHERE Tabela='Dziennik'";
                    IdDziennik = (int)cmd.ExecuteScalar();

                    cmd.CommandText = "UPDATE Sekwencje SET Liczba=Liczba+1 WHERE Tabela='Dziennik'";
                    cmd.ExecuteNonQuery();

                    transaction.Commit();


                    transaction = connection.BeginTransaction();
                    cmd.Transaction = transaction;

                    cmd.CommandText = "INSERT INTO Osoba (ID, Imie, Nazwisko, Pensja) VALUES(@id, @imie, @nazwisko, @pensja)";
                    cmd.Parameters.Clear();
                    cmd.Parameters.Add("id", SqlDbType.Int).Value = IdOsoba;
                    cmd.Parameters.Add("imie", SqlDbType.VarChar, 30).Value = "Jan" + i;
                    cmd.Parameters.Add("nazwisko", SqlDbType.VarChar, 50).Value = "Kowalski" + i;
                    cmd.Parameters.Add("pensja", SqlDbType.Int).Value = 1500 + i;
                    cmd.ExecuteNonQuery();

                    cmd.CommandText = "INSERT INTO Dziennik (ID, Tabela, RekordID, Operacja, Data) VALUES(@id, @tabela, @rekordid, @operacja, @data)";
                    cmd.Parameters.Clear();
                    cmd.Parameters.Add("id", SqlDbType.Int).Value = IdDziennik;
                    cmd.Parameters.Add("tabela", SqlDbType.VarChar, 255).Value = "Osoba";
                    cmd.Parameters.Add("rekordid", SqlDbType.Int).Value = IdOsoba;
                    cmd.Parameters.Add("operacja", SqlDbType.VarChar, 10).Value = "INSERT";
                    cmd.Parameters.Add("data", SqlDbType.DateTime).Value = DateTime.Now;
                    cmd.ExecuteNonQuery();

                    transaction.Commit();

                }
                catch (Exception e)
                {
                    transaction.Rollback();
                    Console.WriteLine("AWARIA");
                    Console.WriteLine(e.Message);
                    Console.WriteLine("------------");
                }
            }
            connection.Close();
            Console.WriteLine("OK");
            Console.ReadLine();
        }
    }
}
