/* 
 * 
 * Przykad na podstawie: Bipin Joshi, et al., Professional ADO.NET Programming, Wrox
 * 
 */


/* Przygotowanie bazy danych

drop table Osoba;

create table Osoba(
  ID int not null primary key identity,
  Imie varchar(30) default 'Jan',
  Nazwisko varchar(50) default 'Kowalski',
);

begin
  delete from Osoba;
  insert into Osoba values( 'Jan', 'Kowalski' );
  insert into Osoba values( 'Ewa', 'Solska' );
  insert into Osoba values( 'Boydar', 'Nowak' );
  insert into Osoba values( 'Adam', 'Adamski' );
  insert into Osoba values( 'Zygmunt', 'Riposta' );
  insert into Osoba values( 'Alicja', 'Gleba' );
  insert into Osoba values( 'Tania', 'Borwka' );
  insert into Osoba values( 'Natasza', 'Lizacka' );
  insert into Osoba values( 'Stan', 'Taczkowski' );
end;

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace TransactionsSavePoints
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection connection;
            SqlCommand command;
            SqlTransaction transaction;
            SqlDataReader reader;
            connection = new SqlConnection("Data Source=DRACULA\\SQLEXPRESS; Initial Catalog=KursPBD; Integrated Security=true");
            connection.Open();
            transaction = connection.BeginTransaction();
            command = new SqlCommand();
            command.Connection = connection;
            command.Transaction = transaction;
            try
            {
                command.CommandText = "INSERT INTO Osoba DEFAULT VALUES";
                command.ExecuteNonQuery();
                transaction.Save("osoba01");
                command.CommandText = "INSERT INTO Osoba DEFAULT VALUES";
                command.ExecuteNonQuery();
                command.CommandText = "INSERT INTO Osoba DEFAULT VALUES";
                command.ExecuteNonQuery();
                transaction.Rollback("osoba01");
                command.CommandText = " INSERT INTO Osoba DEFAULT VALUES";
                command.ExecuteNonQuery();
                command.CommandText = " INSERT INTO Osoba DEFAULT VALUES";
                command.ExecuteNonQuery();
                transaction.Commit();
                command.CommandText = "SELECT TOP 3 ID FROM Osoba ORDER BY ID DESC";
                reader = command.ExecuteReader();
                Console.WriteLine("Ostatnie 3 osoby");
                while (reader.Read())
                {
                    Console.WriteLine(reader.GetInt32(0));
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            finally
            {
                connection.Close();
            }
            Console.ReadLine();
        }
    }
}
